/*
   Copyright 2000, 2001, 2002, 2003 Laurent Wacrenier

   This file is part of PLL lmtpd.

   PLL lmtpd is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   PLL lmtpd is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with PLL lmtpd; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "config.h"

static char const rcsid[] UNUSED =
"$Id: isheader.c,v 1.7 2004/10/26 09:59:20 lwa Exp $";


#include <ctype.h>
#include <string.h>

/*
 * verify that a string is a valid header
 */

char *isheader(char *s) {
  char *s0=s;
  while(*s) {
    if (*s == ':')
      return s0;
    if (*s<33 || *s>126) /* RFC 2822, 3.6.8 */
      return NULL;
    s++;
  }
  return NULL;
}

