struct identifier {
  char *name;
  int op;
};

struct string {
  char *name;
  int op;
};

struct token {
  union { 
    char *string;
    unsigned long number;
  } value;
  int op;
  unsigned int flags;
};

#define SIEVE_TOKEN_TEST        0x01
#define SIEVE_TOKEN_COMMAND     0x02
#define SIEVE_TOKEN_MODIFIER    0x04

#define SIEVE_TOKEN_BASE        1000
#define SIEVE_STRING_BASE       1000


#define SIEVE_NUMBER                          SIEVE_TOKEN_BASE+1
#define SIEVE_STRING                          SIEVE_TOKEN_BASE+2
#define SIEVE_IF                              SIEVE_TOKEN_BASE+3
#define SIEVE_ELSIF                           SIEVE_TOKEN_BASE+4
#define SIEVE_ELSE                            SIEVE_TOKEN_BASE+5
#define SIEVE_REQUIRE                         SIEVE_TOKEN_BASE+6
#define SIEVE_SEMICOLON                       SIEVE_TOKEN_BASE+7
#define SIEVE_STOP                            SIEVE_TOKEN_BASE+8
#define SIEVE_REJECT                          SIEVE_TOKEN_BASE+9
#define SIEVE_FILEINTO                       SIEVE_TOKEN_BASE+10
#define SIEVE_REDIRECT                       SIEVE_TOKEN_BASE+11
#define SIEVE_KEEP                           SIEVE_TOKEN_BASE+12
#define SIEVE_DISCARD                        SIEVE_TOKEN_BASE+13
#define SIEVE_ADDRESS                        SIEVE_TOKEN_BASE+14
#define SIEVE_ALLOF                          SIEVE_TOKEN_BASE+15
#define SIEVE_ANYOF                          SIEVE_TOKEN_BASE+16
#define SIEVE_ENVELOPE                       SIEVE_TOKEN_BASE+17
#define SIEVE_EXISTS                         SIEVE_TOKEN_BASE+18
#define SIEVE_FALSE                          SIEVE_TOKEN_BASE+19
#define SIEVE_NOT                            SIEVE_TOKEN_BASE+20
#define SIEVE_SIZE                           SIEVE_TOKEN_BASE+21
#define SIEVE_OVER                           SIEVE_TOKEN_BASE+22
#define SIEVE_UNDER                          SIEVE_TOKEN_BASE+23
#define SIEVE_TRUE                           SIEVE_TOKEN_BASE+24
#define SIEVE_ALL                            SIEVE_TOKEN_BASE+32
#define SIEVE_LOCALPART                      SIEVE_TOKEN_BASE+33
#define SIEVE_DOMAIN                         SIEVE_TOKEN_BASE+34
#define SIEVE_IS                             SIEVE_TOKEN_BASE+35
#define SIEVE_CONTAINS                       SIEVE_TOKEN_BASE+36
#define SIEVE_MATCHES                        SIEVE_TOKEN_BASE+37
#define SIEVE_COMPARATOR                     SIEVE_TOKEN_BASE+38
#define SIEVE_EOF                            SIEVE_TOKEN_BASE+39

#define SIEVE_IDENTIFIER                     SIEVE_TOKEN_BASE+40
#define SIEVE_TAG                            SIEVE_TOKEN_BASE+41
#define SIEVE_COUNT                          SIEVE_TOKEN_BASE+42
#define SIEVE_VALUE                          SIEVE_TOKEN_BASE+43

#define SIEVE_HEADER                         SIEVE_TOKEN_BASE+44
#define SIEVE_USER                           SIEVE_TOKEN_BASE+45
#define SIEVE_DETAIL                         SIEVE_TOKEN_BASE+46
#define SIEVE_COPY                           SIEVE_TOKEN_BASE+47
#define SIEVE_SPAMTEST                       SIEVE_TOKEN_BASE+48
#define SIEVE_VIRUSTEST                      SIEVE_TOKEN_BASE+49
#define SIEVE_TEXT                           SIEVE_TOKEN_BASE+50
#define SIEVE_REGEX                          SIEVE_TOKEN_BASE+51

#define SIEVE_STRING_I_OCTET                 SIEVE_STRING_BASE+1
#define SIEVE_STRING_I_ASCII_CASEMAP         SIEVE_STRING_BASE+2
#define SIEVE_STRING_I_ASCII_NUMERIC         SIEVE_STRING_BASE+3
#define SIEVE_STRING_GT                      SIEVE_STRING_BASE+4
#define SIEVE_STRING_GE                      SIEVE_STRING_BASE+5
#define SIEVE_STRING_LT                      SIEVE_STRING_BASE+6
#define SIEVE_STRING_LE                      SIEVE_STRING_BASE+7
#define SIEVE_STRING_EQ                      SIEVE_STRING_BASE+8
#define SIEVE_STRING_NE                      SIEVE_STRING_BASE+9
#define SIEVE_STRING_FILEINTO                SIEVE_STRING_BASE+10
#define SIEVE_STRING_ENVELOPE                SIEVE_STRING_BASE+11
#define SIEVE_STRING_REJECT                  SIEVE_STRING_BASE+12
#define SIEVE_STRING_COMPARATOR_I_ASCII_NUMERIC SIEVE_STRING_BASE+13
#define SIEVE_STRING_RELATIONAL              SIEVE_STRING_BASE+14
#define SIEVE_STRING_SUBADDRESS              SIEVE_STRING_BASE+15
#define SIEVE_STRING_COPY                    SIEVE_STRING_BASE+16
#define SIEVE_STRING_SPAMTEST                SIEVE_STRING_BASE+17
#define SIEVE_STRING_VIRUSTEST               SIEVE_STRING_BASE+18
#define SIEVE_STRING_COMPARATOR_I_OCTET          SIEVE_STRING_BASE+19
#define SIEVE_STRING_COMPARATOR_I_ASCII_CASEMAP  SIEVE_STRING_BASE+20
#define SIEVE_STRING_REGEX                   SIEVE_STRING_BASE+21

